package com.sptg.estate.api.feigns.fallback;

import com.baomidou.mybatisplus.plugins.Page;
import com.sptg.common.core.beans.ResultBean;
import com.sptg.common.core.beans.ResultEnum;
import com.sptg.estate.api.dto.PratiqueDto;
import com.sptg.estate.api.entity.Pratique;
import com.sptg.estate.api.feigns.PratiqueFeign;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * Created By lidexi in 2021/1/8
 * 防疫通行对外接口容错处理
 **/
@Component
@Slf4j
public class PratiqueFeignFallbackFactory implements FallbackFactory<PratiqueFeign> {
    @Override
    public PratiqueFeign create(Throwable cause) {
        return new PratiqueFeign() {
            @Override
            public ResultBean<Page<Pratique>> showPratiqueList(PratiqueDto pratiqueDto) {
                log.error(cause.getMessage(), cause);
                return new ResultBean<>(ResultEnum.ERROR);
            }

            @Override
            public ResultBean<Pratique> addPratique(PratiqueDto pratiqueDto) {
                log.error(cause.getMessage(), cause);
                return new ResultBean<>(ResultEnum.ERROR);
            }

            @Override
            public Pratique findPratiqueById(Long id) {
                log.error(cause.getMessage(), cause);
                return null;
            }

            @Override
            public ResultBean<Boolean> updatePratique(PratiqueDto pratiqueDto) {
                log.error(cause.getMessage(), cause);
                return new ResultBean<>(ResultEnum.ERROR);
            }

            @Override
            public ResultBean<Boolean> deletePratique(PratiqueDto pratiqueDto) {
                log.error(cause.getMessage(), cause);
                return new ResultBean<>(ResultEnum.ERROR);
            }

            @Override
            public ResultBean<Boolean> deletePratiqueList(PratiqueDto pratiqueDto) {
                log.error(cause.getMessage(), cause);
                return new ResultBean<>(ResultEnum.ERROR);
            }


            @Override
            public List<Pratique> getListByCondition(PratiqueDto pratiqueDto) {
                log.error(cause.getMessage(),cause);
                return null;
            }
        };
    }
}
